function updatePickerByIndexSelected() {
//    console.debug("AICalendarPickerJS: updatePickerByIndexSelected");
//    console.debug("Next Review: " + sqlDTS1);
//    console.debug("Start Date: " + sqlDTS2);
//    console.debug("Due Date: " + sqlDTS3);
//    console.debug("Grid selection: " + segmentGrid.currentIndex);

    if (segmentGrid.currentIndex == 1) setDatePickerFromString(sqlDTS2)
    else if (segmentGrid.currentIndex == 2) setDatePickerFromString(sqlDTS3)
    else setDatePickerFromString(sqlDTS1)

    updateFooter();
}

function updateFooter() {
//    console.debug("AICalendarPickerJS: updateFooter");

    var newDTS = composeDTSFromSelection();

    if (segmentGrid.currentIndex == 0) {

        if (newDTS == "") footerLabel.text = qsTr("Next Review not set");
        else footerLabel.text = qsTr("Next Review on ") + composeDTSFromSelection();

    } else if (segmentGrid.currentIndex == 1) {
        if (newDTS == "") footerLabel.text = qsTr("Start Date not set");
        else footerLabel.text = qsTr("Start on ") + composeDTSFromSelection();

    } else if (segmentGrid.currentIndex == 2) {
        if (newDTS == "") footerLabel.text = qsTr("Due Date not set");
        else footerLabel.text = qsTr("Due on ") + composeDTSFromSelection();
    }
}

function composeDTSFromSelection() {
    var newDTS = ""

//    if (aiCalendarPicker.enabled) {
//        newDTS = zeroPad(aiCalendarPicker.theYear, 4) + "-" + zeroPad(aiCalendarPicker.theMonth, 2) + "-" + zeroPad(aiCalendarPicker.theDay, 2);
//        newDTS += " " + aiCalendarPicker.theTime

//        newDTS += " +0000"

//        console.debug("YEAR: " + aiCalendarPicker.theYear)
//        console.debug("MONTH: " + aiCalendarPicker.theMonth)
//        console.debug("DAY: " + aiCalendarPicker.theDay)

//        newDTS = zeroPad(aiCalendarPicker.theYear, 4) + "-" + zeroPad(aiCalendarPicker.theMonth, 2) + "-" + zeroPad(aiCalendarPicker.theDay, 2);
//        newDTS += " " + zeroPad(aiCalendarPicker.theTime.substring(0,2), 2) + ":" + zeroPad(aiCalendarPicker.theTime.substring(3,5), 2) + ":00";

//        var d = new Date()
//        console.debug(d)

//        var off = d.getTimezoneOffset()
//        var gmtHours

//        if (off < 0) { newDTS += " +"; gmtHours = -d.getTimezoneOffset()/60; }
//        else { newDTS += " -"; gmtHours = d.getTimezoneOffset()/60; }

//        newDTS += zeroPad(gmtHours, 2) + "00"
//    }

    if (aiCalendarPicker.enabled) {
        newDTS = zeroPad(aiCalendarPicker.displayYear, 4) + "-" + zeroPad(aiCalendarPicker.displayMonth, 2) + "-" + zeroPad(aiCalendarPicker.theDay, 2);
        newDTS += " " + aiCalendarPicker.theTime

        newDTS += " +0000"

//        console.debug("YEAR: " + aiCalendarPicker.displayYear)
//        console.debug("MONTH: " + aiCalendarPicker.displayMonth)
//        console.debug("DAY: " + aiCalendarPicker.theDay)

        newDTS = zeroPad(aiCalendarPicker.displayYear, 4) + "-" + zeroPad(aiCalendarPicker.displayMonth, 2) + "-" + zeroPad(aiCalendarPicker.theDay, 2);
        newDTS += " " + zeroPad(aiCalendarPicker.theTime.substring(0,2), 2) + ":" + zeroPad(aiCalendarPicker.theTime.substring(3,5), 2) + ":00";

        var d = new Date()
//        console.debug(d)

        var off = d.getTimezoneOffset()
        var gmtHours

        if (off < 0) { newDTS += " +"; gmtHours = -d.getTimezoneOffset()/60; }
        else { newDTS += " -"; gmtHours = d.getTimezoneOffset()/60; }

        newDTS += zeroPad(gmtHours, 2) + "00"
    }

    return newDTS;
}

function dateDeselected() {
//    console.debug("AICalendarPickerJS: dateDeselected");
    var newDTS = ""

    if (segmentGrid.currentIndex == 0) {
        sqlDTS1 = newDTS;
        QtHandler.dateSelected(newDTS);

    } else if (segmentGrid.currentIndex == 1) {
        sqlDTS2 = newDTS;
        QtHandler.startDateSelected(newDTS);

    } else {
        sqlDTS3 = newDTS;
        QtHandler.dueDateSelected(newDTS);
    }

    updatePickerByIndexSelected();
}

function dateSelected() {
//    console.debug("AICalendarPickerJS: dateSelected");

    var newDTS = composeDTSFromSelection();
//    console.debug("newDTS: " + newDTS)
    //updateFooter();

    if (segmentGrid.currentIndex == 0) {
        sqlDTS1 = newDTS;
        QtHandler.dateSelected(newDTS);

    } else if (segmentGrid.currentIndex == 1) {
        sqlDTS2 = newDTS;
        QtHandler.startDateSelected(newDTS);

    } else {
        sqlDTS3 = newDTS;
        QtHandler.dueDateSelected(newDTS);
    }

    updatePickerByIndexSelected();
}

function zeroPad(num,count) {
    var numZeropad = num + '';
    while(numZeropad.length < count) {
        numZeropad = "0" + numZeropad;
    }
    return numZeropad;
}

function setDatePicker(d) {
//    console.debug("AICalendarPickerJS: setDatePicker")
//    console.debug(d.toString() + " --> " + d.getFullYear() + "-" + (d.getMonth()+1) + "-" + d.getDate())

    aiCalendarPicker.theYear = d.getFullYear()
    aiCalendarPicker.theMonth = d.getMonth()+1
    aiCalendarPicker.theDay = d.getDate()
    loadSelectedMonth();

    aiCalendarPicker.theTime = d.toLocaleTimeString()
    loadSelectedTime();
}

function setDatePickerFromString(text) {
//    console.debug("AICalendarPickerJS: setDatePickerFromString " + text)

    var date = new Date()

    if (text === '') {
        aiCalendarPicker.enabled = false
        timePicker.enabled = false
        loadNow();

    } else {
        date.setFullYear(parseInt(text.substr(0,4), 10), parseInt(text.substr(5,2), 10)-1, parseInt(text.substr(8,2), 10))

        var hours = parseInt(text.substr(11,2), 10);
        var minutes = parseInt(text.substr(14,2), 10);
        var seconds = parseInt(text.substr(17,2), 10);

        date.setHours(hours)
        date.setMinutes(minutes)
        date.setSeconds(seconds)

//        console.debug(date.toGMTString())

        aiCalendarPicker.enabled = true

        if (hours === 0 && minutes === 0 && seconds === 0) timePicker.enabled = false;
        else timePicker.enabled = true;
    }

    if (date === null) console.debug("date is null")
    else setDatePicker(date)
}

function getCalendarDate() {
    var months = new Array(13);
    months[0]  = qsTr("January");
    months[1]  = qsTr("February");
    months[2]  = qsTr("March");
    months[3]  = qsTr("April");
    months[4]  = qsTr("May");
    months[5]  = qsTr("June");
    months[6]  = qsTr("July");
    months[7]  = qsTr("August");
    months[8]  = qsTr("September");
    months[9]  = qsTr("October");
    months[10] = qsTr("November");
    months[11] = qsTr("December");
    var now         = new Date();
    var monthnumber = now.getMonth();
    var monthname   = months[monthnumber];
    var monthday    = now.getDate();
    var year        = now.getYear();
    if(year < 2000) { year = year + 1900; }
    var dateString = monthname +
        ' ' +
        monthday +
        ', ' +
        year;
    return dateString;
} // function getCalendarDate()

function getClockTime() {
    var now    = new Date();
    var hour   = now.getHours();
    var minute = now.getMinutes();
    var second = now.getSeconds();

    //       var ap = "AM";
    //       if (hour   > 11) { ap = "PM";             }
    //       if (hour   > 12) { hour = hour - 12;      }
    //       if (hour   == 0) { hour = 12;             }

    if (hour   < 10) { hour   = "0" + hour;   }
    if (minute < 10) { minute = "0" + minute; }
    if (second < 10) { second = "0" + second; }
    //var timeString = hour + ':' + minute + ':' + second + " " + ap;
    var timeString = hour + ":" + minute + ":" + second;

    return timeString;
} // function getClockTime()

function buildCal(m, y){
//    console.debug("AICalendarPickerJS: buildCal");

    //var mn=['January','February','March','April','May','June','July','August','September','October','November','December'];
    var mn = new Array(12);
    mn[0]  = qsTr("January");
    mn[1]  = qsTr("February");
    mn[2]  = qsTr("March");
    mn[3]  = qsTr("April");
    mn[4]  = qsTr("May");
    mn[5]  = qsTr("June");
    mn[6]  = qsTr("July");
    mn[7]  = qsTr("August");
    mn[8]  = qsTr("September");
    mn[9]  = qsTr("October");
    mn[10] = qsTr("November");
    mn[11] = qsTr("December");
    var dim=[31,0,31,30,31,30,31,31,30,31,30,31];

    var oD = new Date(y, m-1, 1); //DD replaced line to fix date bug when current day is 31st
    oD.od=oD.getDay()+1; //DD replaced line to fix date bug when current day is 31st

    var todaydate = new Date() //DD added
    var scanfortoday = (y === todaydate.getFullYear() && m === todaydate.getMonth()+1) ? todaydate.getDate() : 0 //DD added

    var selectiondate = new Date(aiCalendarPicker.theYear, aiCalendarPicker.theMonth-1, aiCalendarPicker.theDay)
    var scanforselection = 0

    if (aiCalendarPicker.enabled) {
        scanforselection = (y === selectiondate.getFullYear() && m === selectiondate.getMonth()+1) ? selectiondate.getDate() : 0 //DD added
    }

    dim[1]=(((oD.getFullYear()%100 !== 0) && (oD.getFullYear()%4 === 0)) || (oD.getFullYear()%400 === 0)) ? 29 : 28;

    aiCalendarPicker.currentMonth = mn[m-1];
    aiCalendarPicker.currentYear = y;

    xlwd1.operation = qsTr("Su");
    xlwd2.operation = qsTr("Mo");
    xlwd3.operation = qsTr("Tu");
    xlwd4.operation = qsTr("We");
    xlwd5.operation = qsTr("Th");
    xlwd6.operation = qsTr("Fr");
    xlwd7.operation = qsTr("Sa");

    var buttons = [xld01, xld02, xld03, xld04, xld05, xld06, xld07, xld11, xld12, xld13, xld14, xld15, xld16, xld17,
                   xld21, xld22, xld23, xld24, xld25, xld26, xld27, xld31, xld32, xld33, xld34, xld35, xld36, xld37,
                   xld41, xld42, xld43, xld44, xld45, xld46, xld47, xld51, xld52, xld53, xld54, xld55, xld56, xld57]

    var i
    for(i=1; i<=42; i++) {
        var x=((i-oD.od>=0)&&(i-oD.od<dim[m-1]))? i-oD.od+1 : '';

        //console.debug("next value:" + x + " selected:" + scanforselection + " today:" + scanfortoday)

        if (x !== '') {
            buttons[i-1].operation = x
            buttons[i-1].enabled = true
            buttons[i-1].opcode = "d";

            if (scanfortoday !== 0 && x === scanfortoday) buttons[i-1].framed = true
            else buttons[i-1].framed = false

            if (scanforselection !== 0 && x === scanforselection) buttons[i-1].selected = true
            else buttons[i-1].selected = false

        } else {
            buttons[i-1].operation = ""
            buttons[i-1].enabled = false
            buttons[i-1].selected = false
            buttons[i-1].framed = false
            buttons[i-1].opcode = "";
        }

    }
}

function buildClock() {
//    console.debug("AICalendarPickerJS: buildClock");

    var USClock = true

    var scanforhourselection = -1;
    var scanforminuteselection = -1;

    if (timePicker.enabled) {
        if (theTime != "") {
            scanforhourselection = parseInt(theTime.substr(0,2), 10);
            scanforminuteselection = Math.floor(parseInt(theTime.substr(3,2), 10) / 5);

//            console.debug("SCAN FOR " + scanforhourselection + " h AND " + scanforminuteselection + " m in " + theTime)
        }
    }

    var buttons = [xlt01, xlt02, xlt03, xlt04, xlt05, xlt06,
                   xlt11, xlt12, xlt13, xlt14, xlt15, xlt16,
                   xlt21, xlt22, xlt23, xlt24, xlt25, xlt26,
                   xlt31, xlt32, xlt33, xlt34, xlt35, xlt36];

    var i
    for(i=0; i<=23; i++) {
        buttons[i].enabled = true;
        buttons[i].framed = false;

        if (scanforhourselection == i) buttons[i].selected = true;
        else buttons[i].selected = false;

        if (USClock) {
            var hour

            if (i >= 12) {
                buttons[i].opcode = "p";
                hour = i-12;
            } else {
                buttons[i].opcode = "a";
                hour = i;
            }

            if (hour === 0) hour = 12;

            buttons[i].operation = hour;

        } else {
            buttons[i].operation = i;
            buttons[i].opcode = "h";
        }
    }

    var minuteButtons = [xlm01, xlm11, xlm02, xlm12, xlm03, xlm13, xlm04, xlm14, xlm05, xlm15, xlm06, xlm16];

    for (i=1; i<=12; i++) {
        minuteButtons[i-1].operation = (i-1)*5;
        minuteButtons[i-1].enabled = true;
        minuteButtons[i-1].framed = false;
        minuteButtons[i-1].opcode = "m";

        if (scanforminuteselection === i-1) minuteButtons[i-1].selected = true;
        else minuteButtons[i-1].selected = false;
    }
}

function loadNow() {
//    console.debug("AICalendarPickerJS: loadNow");

    var todaydate = new Date();

//    theMonth = todaydate.getMonth()+1 //get current month (1-12)
//    theYear = todaydate.getFullYear() //get current year
//    theDay = todaydate.getDate() // get current date

//    loadSelectedMonth()

    displayMonth = todaydate.getMonth()+1 //get current month (1-12)
    displayYear = todaydate.getFullYear() //get current year

    loadMonth(displayMonth, displayYear)
}

function loadMonth(m, y) {
    buildCal(m, y);
}

function loadSelectedMonth() {
//    console.debug("AICalendarPickerJS: loadSelectedMonth:" + theMonth)

    if (theMonth <= 12) {
        buildCal(theMonth, theYear);
        displayMonth = theMonth
        displayYear = theYear
    } else {
        aiCalendarPicker.enabled = false
    }
}

function loadSelectedTime() {
//    console.debug("AICalendarPickerJS: loadSelectedTime:" + theTime)

    buildClock();
}

function doOp(opcode, operation) {
//    console.debug("AICalendarPickerJS: doOp " + operation + " with opcode " + opcode)
//    console.debug("theTime:" + theTime)

    if (opcode === "d") {
        theDay = operation
        aiCalendarPicker.enabled = true

    } else if (opcode === "h") {
        theTime = zeroPad(parseInt(operation), 2) + ":" + theTime.substr(3,2) + ":00";
        aiCalendarPicker.enabled = true
        timePicker.enabled = true

    } else if (opcode === "a") {
        var hour = parseInt(operation);
        if (hour === 12) hour = 0;

        theTime = zeroPad(hour, 2) + ":" + theTime.substr(3,2) + ":00";
        aiCalendarPicker.enabled = true
        timePicker.enabled = true

    } else if (opcode === "p") {
        var hour = parseInt(operation);
        if (hour != 12) hour += 12;

        theTime = zeroPad(hour, 2) + ":" + theTime.substr(3,2) + ":00";
        aiCalendarPicker.enabled = true
        timePicker.enabled = true

    } else if (opcode === "m") {
        theTime = theTime.substr(0,2) + ":" + zeroPad(parseInt(operation), 2) + ":00";
        aiCalendarPicker.enabled = true
        timePicker.enabled = true

    }

    dateSelected()
}

function switchTimeSelection(enabled) {

    if (enabled === true) {
        var time = getClockTime()
        var minutes = Math.floor(parseInt(theTime.substr(3,2), 10) / 5) * 5;

        theTime = time.substr(0,2) + ":" + zeroPad(minutes, 2) + ":00";

    } else {
        theTime = "00:00:00";
    }

    dateSelected()
}
